#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <stdarg.h>

#include "sysdep.h"
#include "feature.h"
#include "console.h"
#include "gui.h"
#include "s_files.h"
#include "c_history.h"

#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qbutton.h>
#include <qpushbt.h>
#include <qfiledlg.h>
#include <qlined.h>
#include <qlayout.h>
#include <qcombo.h>
#include <qchkbox.h>

#define DEBUGX(x) // printf x

unsigned long HaveGUIDialogs = GUIDLG_FILE | GUIDLG_CHOICE | GUIDLG_PROMPT | GUIDLG_FIND | GUIDLG_FINDREPLACE;

class PromptDlg : public QDialog
{

    Q_OBJECT

public:
    
    PromptDlg ();
    
    virtual ~PromptDlg() {};
    
    QLabel* label;
    QComboBox* entry;
    
    
};

class FindDlg : public QDialog
{
    Q_OBJECT
public:
    FindDlg (long options=0);
    virtual ~FindDlg() {};

    QComboBox* entry;
    QCheckBox *a;
    QCheckBox *b;
    QCheckBox *c;
    QCheckBox *d;
    QCheckBox *e;
    QCheckBox *g;
    QCheckBox *i;
    QCheckBox *j;
    QCheckBox *r;
    QCheckBox *x;
    
};

class FindReplaceDlg : public QDialog
{
    Q_OBJECT
public:
    FindReplaceDlg (long options=0);
    virtual ~FindReplaceDlg() {};

    QComboBox* entry;
    QComboBox* entry2;
    QCheckBox *a;
    QCheckBox *b;
    QCheckBox *c;
    QCheckBox *d;
    QCheckBox *e;
    QCheckBox *g;
    QCheckBox *i;
    QCheckBox *j;
    QCheckBox *r;
    QCheckBox *x;
    
};

PromptDlg::PromptDlg
    () : QDialog(0,0, TRUE )
{
    
    label=new QLabel ("label",this);
    entry=new QComboBox (true,this);
    QPushButton *b1=new QPushButton(this);
    QPushButton *b2=new QPushButton(this);
    b1->setText("Ok");
    b1->setDefault( true );
    b2->setText("Cancel");
    QObject::connect (b1,SIGNAL(clicked()),SLOT(accept()));
    QObject::connect (b2,SIGNAL(clicked()),SLOT(reject()));
    entry->setFocus();


    label->setMinimumSize(label->sizeHint());
    entry->setMinimumSize(entry->sizeHint());
    b1->setMinimumSize(b1->sizeHint());
    b2->setMinimumSize(b2->sizeHint());

    
    if (b1->minimumSize().width() <75)
        b1->setFixedWidth(75);
    if (b2->minimumSize().width() <75)
        b2->setFixedWidth(75);


    QVBoxLayout *v=new QVBoxLayout(this,5,5);
    QHBoxLayout *h=new QHBoxLayout();
    v->addWidget(label,1);
    v->addWidget(entry,1);
    v->addLayout(h,0);
    h->addWidget(b1,0);
    h->addStretch(10);
    h->addWidget(b2,0);
    v->activate();
    
    resize(250,10);   
}

FindDlg::FindDlg
    (long options) : QDialog(0,0, TRUE )
{
    
    QLabel *label=new QLabel ("Find",this);
    entry=new QComboBox (true,this);
    QPushButton *b1=new QPushButton(this);
    QPushButton *b2=new QPushButton(this);
    b1->setText("Ok");
    b1->setDefault( true );
    b2->setText("Cancel");
    QObject::connect (b1,SIGNAL(clicked()),SLOT(accept()));
    QObject::connect (b2,SIGNAL(clicked()),SLOT(reject()));
    entry->setFocus();
    
    a=new QCheckBox("All Occurences",this);
    a->setChecked(options & SEARCH_ALL);
    b=new QCheckBox("In Block",this);
    b->setChecked(options & SEARCH_BLOCK);
    c=new QCheckBox("Center finds",this);
    c->setChecked(options & SEARCH_CENTER);
    d=new QCheckBox("Delete Line",this);
    d->setChecked(options & SEARCH_DELETE);
    e=new QCheckBox("e option??",this);
    e->setChecked(false);
    g=new QCheckBox("Global Search",this);
    g->setChecked(options & SEARCH_GLOBAL);
    i=new QCheckBox("Ignore Case",this);
    i->setChecked(options & SEARCH_NCASE);
    j=new QCheckBox("Join Line",this);
    j->setChecked(options & SEARCH_JOIN);
    r=new QCheckBox("Reverse search",this);
    r->setChecked(options & SEARCH_BACK);
    x=new QCheckBox("Use RegExp",this);
    x->setChecked(options & SEARCH_RE);


    label->setMinimumSize(label->sizeHint());
    entry->setMinimumSize(entry->sizeHint());
    b1->setMinimumSize(b1->sizeHint());
    b2->setMinimumSize(b2->sizeHint());
    a->setMinimumSize(a->sizeHint());
    b->setMinimumSize(b->sizeHint());
    c->setMinimumSize(c->sizeHint());
    d->setMinimumSize(d->sizeHint());
    e->setMinimumSize(e->sizeHint());
    g->setMinimumSize(g->sizeHint());
    i->setMinimumSize(i->sizeHint());
    j->setMinimumSize(j->sizeHint());
    r->setMinimumSize(r->sizeHint());
    x->setMinimumSize(x->sizeHint());

    
    if (b1->minimumSize().width() <75)
        b1->setFixedWidth(75);
    if (b2->minimumSize().width() <75)
        b2->setFixedWidth(75);


    QVBoxLayout *v=new QVBoxLayout(this,5,5);
    QHBoxLayout *h=new QHBoxLayout();
    QGridLayout *gr=new QGridLayout(5,2,5);
    v->addWidget(label,1);
    v->addWidget(entry,1);

    v->addLayout(gr,1);
    gr->addWidget(a,0,0);
    gr->addWidget(b,0,1);
    gr->addWidget(c,1,0);
    gr->addWidget(d,1,1);
    gr->addWidget(e,2,0);
    gr->addWidget(g,2,1);
    gr->addWidget(i,3,0);
    gr->addWidget(j,3,1);
    gr->addWidget(r,4,0);
    gr->addWidget(x,4,1);
    
    v->addLayout(h,0);
    h->addWidget(b1,0);
    h->addStretch(10);
    h->addWidget(b2,0);
    v->activate();
    
    resize(250,10);   
}

FindReplaceDlg::FindReplaceDlg
    (long options) : QDialog(0,0, TRUE )
{
    
    QLabel *label=new QLabel ("Find",this);
    QLabel *label2=new QLabel ("Replace with",this);
    entry=new QComboBox (true,this);
    entry2=new QComboBox (true,this);
    QPushButton *b1=new QPushButton(this);
    QPushButton *b2=new QPushButton(this);
    b1->setText("Ok");
    b1->setDefault( true );
    b2->setText("Cancel");
    QObject::connect (b1,SIGNAL(clicked()),SLOT(accept()));
    QObject::connect (b2,SIGNAL(clicked()),SLOT(reject()));
    entry->setFocus();
    
    a=new QCheckBox("All Occurences",this);
    a->setChecked(options & SEARCH_ALL);
    b=new QCheckBox("In Block",this);
    b->setChecked(options & SEARCH_BLOCK);
    c=new QCheckBox("Center finds",this);
    c->setChecked(options & SEARCH_CENTER);
    d=new QCheckBox("Delete Line",this);
    d->setChecked(options & SEARCH_DELETE);
    e=new QCheckBox("e option??",this);
    e->setChecked(false);
    g=new QCheckBox("Global Search",this);
    g->setChecked(options & SEARCH_GLOBAL);
    i=new QCheckBox("Ignore Case",this);
    i->setChecked(options & SEARCH_NCASE);
    j=new QCheckBox("Join Line",this);
    j->setChecked(options & SEARCH_JOIN);
    r=new QCheckBox("Reverse search",this);
    r->setChecked(options & SEARCH_BACK);
    x=new QCheckBox("Use RegExp",this);
    x->setChecked(options & SEARCH_RE);


    label->setMinimumSize(label->sizeHint());
    entry->setMinimumSize(entry->sizeHint());
    label2->setMinimumSize(label2->sizeHint());
    entry2->setMinimumSize(entry2->sizeHint());
    b1->setMinimumSize(b1->sizeHint());
    b2->setMinimumSize(b2->sizeHint());
    a->setMinimumSize(a->sizeHint());
    b->setMinimumSize(b->sizeHint());
    c->setMinimumSize(c->sizeHint());
    d->setMinimumSize(d->sizeHint());
    e->setMinimumSize(e->sizeHint());
    g->setMinimumSize(g->sizeHint());
    i->setMinimumSize(i->sizeHint());
    j->setMinimumSize(j->sizeHint());
    r->setMinimumSize(r->sizeHint());
    x->setMinimumSize(x->sizeHint());

    
    if (b1->minimumSize().width() <75)
        b1->setFixedWidth(75);
    if (b2->minimumSize().width() <75)
        b2->setFixedWidth(75);


    QVBoxLayout *v=new QVBoxLayout(this,5,5);
    QHBoxLayout *h=new QHBoxLayout();
    QGridLayout *gr=new QGridLayout(5,2,5);
    v->addWidget(label,1);
    v->addWidget(entry,1);
    v->addWidget(label2,1);
    v->addWidget(entry2,1);

    v->addLayout(gr,1);
    gr->addWidget(a,0,0);
    gr->addWidget(b,0,1);
    gr->addWidget(c,1,0);
    gr->addWidget(d,1,1);
    gr->addWidget(e,2,0);
    gr->addWidget(g,2,1);
    gr->addWidget(i,3,0);
    gr->addWidget(j,3,1);
    gr->addWidget(r,4,0);
    gr->addWidget(x,4,1);
    
    v->addLayout(h,0);
    h->addWidget(b1,0);
    h->addStretch(10);
    h->addWidget(b2,0);
    v->activate();
    
    resize(250,10);   
}



int DLGGetFile(GView *v, char *Prompt, unsigned int BufLen, char *FileName, int Flags) {
    QString fn;
    char filter[MAXPATH] = "*";
    char directory[MAXPATH];

    assert(BufLen > 0);

    JustDirectory(FileName, directory);

    DEBUGX(("Doing file dialog\n"));
    if (Flags & GF_SAVEAS) {
        fn = QFileDialog::getSaveFileName(directory, filter);
    } else {
        fn = QFileDialog::getOpenFileName(directory, filter);
    }
    DEBUGX(("File dialog done\n"));
    if (fn.isNull())
        return 0;
    strncpy(FileName, fn, BufLen);
    FileName[BufLen - 1] = 0;
    DEBUGX(("selected %s\n", FileName));
    return FileName[0] ? 1 : 0;
}

const int kMaxButton = 16;

class QChoiceBox : public QDialog {
    Q_OBJECT
public:
    QChoiceBox(QWidget *parent=0, const char *name=0);

    void setText(const char *text);
    void addButton(const char *text);

    void adjustSize();

    int getChoice() { return buttonActivated; }

public slots:
    void pressed();
    void released();
    void clicked();

protected:
    void resizeEvent(QResizeEvent *);

private:
    QLabel *label;
    QPushButton *button[kMaxButton];
    int buttonCount;
    int buttonArmed;
    int buttonSelected;
    int buttonActivated;
    void *reserved1;
    void *reserved2;
};


QChoiceBox::QChoiceBox(QWidget *parent, const char *name)
    : QDialog(parent, name, TRUE)
{
    initMetaObject();

    buttonSelected = -1;
    buttonCount = 0;
    buttonActivated = -1;
    buttonArmed = -1;
    
    label = new QLabel(this, "text");
    CHECK_PTR(label);
    label->setAlignment(AlignLeft);
    QFont font("Helvetica", 12, QFont::Bold);
    label->setFont(font );
}

void QChoiceBox::setText(const char *text) {
    label->setText(text);
}

void QChoiceBox::addButton(const char *text) {
    assert(buttonCount < kMaxButton);

    button[buttonCount] = new QPushButton(this);
    CHECK_PTR(button[buttonCount]);
    connect(button[buttonCount], SIGNAL(clicked()), SLOT(clicked()));
    connect(button[buttonCount], SIGNAL(pressed()), SLOT(pressed()));
    connect(button[buttonCount], SIGNAL(released()), SLOT(released()));
    button[buttonCount]->setFont(QFont("Helvetica", 12, QFont::Bold));
    button[buttonCount]->setText(text ? text : "?" );
    buttonCount++;
}

void QChoiceBox::adjustSize() {
    int w_buttons = 0;

    for (int i = 0; i < buttonCount; i++) {
        button[i]->adjustSize();
        w_buttons += button[i]->width() + 10;
    }

    label->adjustSize();
        
    QString labelStr = label->text();
    int nlines = labelStr.contains('\n');
    QFontMetrics fm = label->fontMetrics();
    nlines += 2;
    int w = QMAX(w_buttons, label->width());
    int h = button[0]->height() + fm.lineSpacing()*nlines;
    resize( w + w/3, h + h/3 );
}

void QChoiceBox::resizeEvent( QResizeEvent * ) {
    int i;
    
    for (i = 0; i < buttonCount; i++) {
        button[i]->adjustSize();
    }
    label->adjustSize();
    int h = (height() - button[0]->height() - label->height())/3;
    int x = 10;

    for (i = 0; i < buttonCount; i++) {
        button[i]->move(x, height() - h - button[i]->height());
        x += button[i]->width() + 10;
    }
    label->move( 10, h );
}

void QChoiceBox::pressed() {
    int i;

    buttonSelected = -1;
    for (i = 0; i < buttonCount; i++)
        if (button[i]->isDown())
            buttonSelected = i;
    buttonArmed = buttonSelected;
    DEBUGX(("selected: %d\n", buttonSelected));
}

void QChoiceBox::released() {
    buttonSelected = -1;
    DEBUGX(("released\n"));
}

void QChoiceBox::clicked() {
    buttonActivated = buttonArmed;
    DEBUGX(("activated: %d\n", buttonActivated));
    accept();
}

#include "g_kde_dlg.moc"

int DLGPickChoice(GView *v, char *ATitle, int NSel, va_list ap, int Flags) {
    QChoiceBox *cb = new QChoiceBox();
    CHECK_PTR(cb);
    cb->setCaption( ATitle );

    for (int i = 0; i < NSel; i++)
        cb->addButton(va_arg(ap, char *));

    char msg[1024];
    char *fmt;
    fmt = va_arg(ap, char *);
    vsprintf(msg, fmt, ap);
    
    cb->setText(msg);
    
    int retcode = cb->exec();
    
    delete cb;
    if (retcode == QDialog::Accepted)
        return cb->getChoice();
    return -1;
}

void InsertHistory(QComboBox *combo, int id, int maxlen) {
    int i, count;
    char *str;
    count = CountInputHistory(id);
    
    str = (char *)malloc(maxlen + 1);
    if (str == 0)
        return;
    
    for (i = 0; i < count; i++) {
        if (GetInputHistory(id, str, maxlen, i + 1) == 1)
            combo->insertItem(str);
    }
    free(str);
}

static SearchReplaceOptions SearchOpt;


int DLGGetFind(GView *View, SearchReplaceOptions &sr) {
    
    FindDlg *dlg=new FindDlg(sr.Options);
    InsertHistory (dlg->entry,HIST_SEARCH,50);
    int retcode= dlg->exec();

    sr.ok=0;
    
    if (retcode==QDialog::Accepted)
    {
        sr.ok=1;
        strncpy(sr.strSearch, dlg->entry->currentText(), MAXSEARCH);
        sr.strSearch[MAXSEARCH - 1] = 0;
        AddInputHistory (HIST_SEARCH,sr.strSearch);

        sr.Options=0;
        sr.Options+=dlg->a->isChecked()*SEARCH_ALL;
        sr.Options+=dlg->b->isChecked()*SEARCH_BLOCK;
        sr.Options+=dlg->c->isChecked()*SEARCH_CENTER;
        sr.Options+=dlg->d->isChecked()*SEARCH_DELETE;
        sr.Options+=dlg->e->isChecked()*0;
        sr.Options+=dlg->g->isChecked()*SEARCH_GLOBAL;
        sr.Options+=dlg->i->isChecked()*SEARCH_NCASE;
        sr.Options+=dlg->j->isChecked()*SEARCH_JOIN;
        sr.Options+=dlg->r->isChecked()*SEARCH_BACK;
        sr.Options+=dlg->x->isChecked()*SEARCH_RE;

        return 1;
//        return sr.strSearch[0] ? 1 : 0;
    }
    else return 0;
}



int DLGGetFindReplace(GView *View, SearchReplaceOptions &sr) {

    SearchOpt = sr;

    FindReplaceDlg *dlg=new FindReplaceDlg(sr.Options);
    InsertHistory (dlg->entry,HIST_SEARCH,50);
    InsertHistory (dlg->entry2,HIST_SEARCH,50);
    int retcode= dlg->exec();

    sr.ok=0;
    
    if (retcode==QDialog::Accepted)
    {
        sr.ok=1;
        strncpy(sr.strSearch, dlg->entry->currentText(), MAXSEARCH);
        sr.strSearch[MAXSEARCH - 1] = 0;
        AddInputHistory (HIST_SEARCH,sr.strSearch);

        strncpy(sr.strReplace, dlg->entry2->currentText(), MAXSEARCH);
        sr.strReplace[MAXSEARCH - 1] = 0;
        AddInputHistory (HIST_SEARCH,sr.strReplace);

        sr.Options=0;
        sr.Options+=dlg->a->isChecked()*SEARCH_ALL;
        sr.Options+=dlg->b->isChecked()*SEARCH_BLOCK;
        sr.Options+=dlg->c->isChecked()*SEARCH_CENTER;
        sr.Options+=dlg->d->isChecked()*SEARCH_DELETE;
        sr.Options+=dlg->e->isChecked()*0;
        sr.Options+=dlg->g->isChecked()*SEARCH_GLOBAL;
        sr.Options+=dlg->i->isChecked()*SEARCH_NCASE;
        sr.Options+=dlg->j->isChecked()*SEARCH_JOIN;
        sr.Options+=dlg->r->isChecked()*SEARCH_BACK;
        sr.Options+=dlg->x->isChecked()*SEARCH_RE;
        sr.Options|=SEARCH_REPLACE;

        return 1;
    }
    sr=SearchOpt;
    return 0;
}



int DLGGetStr(GView *View, char *Prompt, unsigned int BufLen, char *Str, int HistId, int Flags) {

    assert(BufLen > 0);
    
    PromptDlg *dlg=new PromptDlg();
    dlg->label->setText(Prompt);
    InsertHistory (dlg->entry,HistId,50);
    dlg->entry->insertItem(Str);
    int retcode= dlg->exec();
    
    if (retcode==QDialog::Accepted)
    {
        strncpy(Str, dlg->entry->currentText(), BufLen);
        Str[BufLen - 1] = 0;
        AddInputHistory (HistId,Str);
        return Str[0] ? 1 : 0;
    }
    else return 0;
}

